SUBROUTINE CGS2(vntemp,V,n,j,WORK)
  IMPLICIT NONE
  INTEGER n,j
  REAL  ONE, ZERO, MINUSONE
  PARAMETER ( ONE = 1.0E+0, ZERO=0.0E+0,MINUSONE = -1.0E+0 )
  REAL V(n,j),vntemp(n),WORK(j)
  if (j .le. 0) return
  CALL SGEMV('T',n,j,ONE,V,n,vntemp,1,ZERO,WORK,1)
  CALL SGEMV('N',n,j,MINUSONE,V,n,WORK,1,ONE,vntemp,1)
  CALL SGEMV('T',n,j,ONE,V,n,vntemp,1,ZERO,WORK,1)
  CALL SGEMV('N',n,j,MINUSONE,V,n,WORK,1,ONE,vntemp,1)
END SUBROUTINE CGS2

SUBROUTINE MGS(K,L,V,WORK2)
  use my_data
  IMPLICIT NONE
  INTEGER I,J,K,L
  REAL ONE, ZERO, MINUSONE
  PARAMETER ( ONE = 1.0E+0, ZERO=0.0E+0,MINUSONE = -1.0E+0 )
  REAL ALPHA,V(K,L),SDOT,WORK2(L)

  DO I=1,L
     ALPHA = SQRT(SDOT(K,V(1,I),1,V(1,I),1))
     DO J=1,K
        V(J,I) = V(J,I)/ALPHA
     ENDDO

     IF (I .LT. L) THEN
        CALL SGEMV('T',K,L-I,ONE,V(1,I+1),K,V(1,I),1,ZERO,WORK2,1)
        CALL SGER(K,L-I,MINUSONE,V(1,I),1,WORK2,1,V(1,I+1),K)
        CALL SGEMV('T',K,L-I,ONE,V(1,I+1),K,V(1,I),1,ZERO,WORK2,1)
        CALL SGER(K,L-I,MINUSONE,V(1,I),1,WORK2,1,V(1,I+1),K)
     ENDIF
  ENDDO

END SUBROUTINE MGS

